=== debian/changelog ===
jazz2-native (3.3.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1088176)

 -- Antoine Le Gonidec <vv221@debian.org>  Mon, 02 Feb 2026 14:37:18 +0100
