## jazz2-native 3.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,19 @@
 	cmake_policy(SET CMP0144 NEW)
 endif()
 
+if(NOT CMAKE_CONFIGURATION_TYPES)
+	get_property(_haveMultiConfigGenerator GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
+	if(_haveMultiConfigGenerator)
+		set(CMAKE_CONFIGURATION_TYPES "Debug;Release")
+	endif()
+endif()
+if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
+	set(_defaultBuildtype "Debug")
+	message(STATUS "Setting build configuration to \"${_defaultBuildtype}\" as none was specified")
+	set(CMAKE_BUILD_TYPE "${_defaultBuildtype}" CACHE STRING "Build configuration" FORCE)
+	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release")
+endif()
+
 # Project metadata
 set(NCINE_ROOT ${CMAKE_SOURCE_DIR})
 set(NCINE_SOURCE_DIR "${NCINE_ROOT}/Sources")
@@ -20,7 +33,7 @@
 set(NCINE_APP_DESCRIPTION_FULL "Jazz² Resurrection is reimplementation of the game Jazz Jackrabbit 2 released in 1998. Supports various versions of the game (Shareware Demo, Holiday Hare '98, The Secret Files and Christmas Chronicles). Also, it partially supports some features of JJ2+ extension and MLLE.\n\nFurther information can be found here: https://deat.tk/jazz2/")
 set(NCINE_APP_VENDOR "Dan R.")
 set(NCINE_REVERSE_DNS "jazz2.resurrection")
-set(NCINE_VERSION "3.3.0")
+set(NCINE_VERSION "3.5.0")
 
 project(Jazz2
 	VERSION "${NCINE_VERSION}"
@@ -29,7 +42,6 @@
 	LANGUAGES CXX C)
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)
-get_filename_component(PARENT_SOURCE_DIR ${CMAKE_SOURCE_DIR} DIRECTORY)
 set_property(GLOBAL PROPERTY USE_FOLDERS ON)
 
 if(NOT CMAKE_GENERATOR_PLATFORM OR "${CMAKE_GENERATOR_PLATFORM}" STREQUAL "${CMAKE_SYSTEM_PROCESSOR}")
@@ -68,10 +80,10 @@
 include(ncine_imgui)
 include(ncine_tracy)
 
-if(NOT IS_DIRECTORY ${NCINE_DATA_DIR})
-	message(WARNING "Content directory not found at: ${NCINE_DATA_DIR}")
+if(NOT IS_DIRECTORY ${NCINE_CONTENT_DIR})
+	message(WARNING "Content directory not found at: ${NCINE_CONTENT_DIR}")
 else()
-	message(STATUS "Content directory: ${NCINE_DATA_DIR}")
+	message(STATUS "Content directory: ${NCINE_CONTENT_DIR}")
 endif()
 	
 if(NCINE_BUILD_ANDROID)
