=== debian/changelog ===
jazz2-native (3.5.0-2) unstable; urgency=medium

  [ Sébastien Noel ]
  * Fix patch to game data files install path.
    (Closes: #1127159)

 -- Antoine Le Gonidec <vv221@debian.org>  Fri, 06 Feb 2026 20:24:47 +0100

jazz2-native (3.5.0-1) unstable; urgency=medium

  * New upstream release.

 -- Antoine Le Gonidec <vv221@debian.org>  Thu, 05 Feb 2026 21:28:16 +0100
