=== debian/control ===
Source: jazz2-native
Section: contrib/games
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Antoine Le Gonidec <vv221@debian.org>,
Homepage: https://deat.tk/jazz2/
Vcs-Browser: https://git.vv221.fr/debian/jazz2-native/
Vcs-Git: https://git.vv221.fr/debian/jazz2-native.git
Standards-Version: 4.7.3
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libcurl4-openssl-dev,
 libopenal-dev,
 libopenmpt-dev,
 libsdl2-dev,
 zlib1g-dev

Package: jazz2-native
Architecture: any
Depends:
 jazz2-native-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Recommends: jazz-jackrabbit-2 | play.it-vv221
Description: Re-implementation of the Jazz Jackrabbit 2 engine
 Jazz² Resurrection is a re-implementation of the game Jazz Jackrabbit 2
 released in 1998. It supports various versions of the game (Shareware Demo,
 Holiday Hare '98, The Secret Files and Christmas Chronicles).
 Also, it partially supports some features of JJ2+ extension and MLLE.
 .
 Jazz² Resurrection supports various versions of the original game,
 but it is recommended to use The Secret Files.
 .
 In addition to this engine, non-free game data files must be provided.
 These data files can be packaged using a tool like ./play.it,
 shipped in the Debian repositories.

Package: jazz2-native-data
Architecture: all
Depends: ${misc:Depends}
Description: Re-implementation of the Jazz Jackrabbit 2 engine (data files)
 Jazz² Resurrection is a re-implementation of the game Jazz Jackrabbit 2
 released in 1998. It supports various versions of the game (Shareware Demo,
 Holiday Hare '98, The Secret Files and Christmas Chronicles).
 Also, it partially supports some features of JJ2+ extension and MLLE.
 .
 This package provides engine data files that are not specific to the host
 architecture. These are not the game data files, that still need to be
 provided in addition to this package.
