=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DNCINE_DOWNLOAD_DEPENDENCIES=OFF -DNCINE_PREFERRED_BACKEND=SDL2 -DNCINE_VERSION_FROM_GIT=OFF -DNCINE_LINUX_PACKAGE=jazz2-native
