=== debian/watch ===
Version: 5

Template: Github
Owner: deathkiller
Project: jazz2-native
